codeforces 141D Take-off Ramps

题意:

有一条起点为0,长度为L的跑道,有n个跳板,对于第i个跳板,在xi处开始起跳,但是必须在xi-pi ~ xi进行缓冲时间为pi,然后在ti的时间到达xi+di处,人可以往回走,但是跳板的方向是固定的,然后求出到达L的最短时间,并且按照起跳顺序的先后输出用了的跳板的编号。

题解:

首先需要明白的是,给出的xi这个点是无用的,那么有用的点只有xi - pi 和 xi + di。

并且转移情况复杂,包括往回走的情况,包括选跳板的情况,不选跳板的情况,走路的情况,当时一时想不出好的解决方法,但是最后发现这不是最短路么?

考虑选择跳板的情况,将跳板的左右端点连一条单向边,权值为pi + ti

考虑不选跳板的情况,将一个点与其他所有点连一条双向边,权值为距离之差,但是发现有很多边都是无用,所以只需要将左右相邻的点相连就好了。

P.S. 数据太大需要离散QAQ,还有SPFA要被卡,会T在第50组,SXBK!

代码:

#include <bits/stdc++.h>
using namespace std;

#define ll long long
const ll inf = 1e15 + 7;
const int N = 1e6 + 7;
struct edge {int u, v, nxt, w, id;}e[N<<2];
struct node {int s, t, w;} rd[N];

int inq[N], disc[N<<1], dis[N], dcnt, head[N], ecnt, n, L, ans[N], cnt, pre[N];

typedef pair <int, int> pii;
#define MK(a,b) make_pair(a, b)

priority_queue <pii, vector <pii>, greater<pii> > q;

void adde (int u, int v, int w, int id) {
	e[ecnt].u = u;
	e[ecnt].v = v;
	e[ecnt].w = w;
	e[ecnt].id = id;
	e[ecnt].nxt = head[u];
	head[u] = ecnt++;
}

void Dijkstra () {
	memset (dis, 127, sizeof dis);
	pre[1] = -1;
	dis[1] = 0;
	q.push(MK(0, 1));
	while (!q.empty()) {
		int u = q.top().second;
		q.pop(); inq[u] = 0;
		for (int it = head[u]; it != -1; it = e[it].nxt) {
			int v = e[it].v;
			if (dis[v] > dis[u] + e[it].w) {
				dis[v] = dis[u] + e[it].w;
				pre[v] = it;
				q.push(MK(dis[v], v));
			}
		}
	}
	for (int it = pre[dcnt]; it != -1; it = pre[e[it].u])
		if (e[it].id != -1) ans[++cnt] = e[it].id;
}

int main () {
	scanf ("%d%d", &n, &L);
	memset (head, -1, sizeof head);
	disc[++dcnt] = 0;
	disc[++dcnt] = L;
	for (int i = 1; i <= n ; ++i) {
		int x, d, t, p;
		scanf ("%d%d%d%d", &x, &d, &t, &p);
		rd[i].s = x - p;
		rd[i].t = x + d;
		rd[i].w = t + p;
		if (x - p < 0 || x + d > L) continue;
		disc[++dcnt] = x - p;
		disc[++dcnt] = x + d;
	}
	sort (disc + 1, disc + 1 + dcnt);
	dcnt = unique (disc + 1, disc + 1 + dcnt) - disc - 1;
	for (int i = 1; i <= n; ++i) {
		if (rd[i].t > L || rd[i].s < 0) continue;
		int s = lower_bound (disc + 1, disc + 1 + dcnt, rd[i].s) - disc;
		int t = lower_bound (disc + 1, disc + 1 + dcnt, rd[i].t) - disc;
		adde (s, t, rd[i].w, i);
	}
	for (int i = 2; i <= dcnt; ++i) {
		int s = i - 1, t = i, w = disc[t] - disc[s];
		adde (s, t, w, -1);
		adde (t, s, w, -1);
	}
	Dijkstra();
	cout << dis[dcnt] << endl << cnt << endl;
	for (int i = cnt; i >= 1; --i) printf ("%d ", ans[i]);
	return 0;
}

  

总结:

复杂的转移关系,简单的限制条件,就可以考虑图论QAQ

时间: 2024-11-03 20:52:20

codeforces 141D Take-off Ramps的相关文章

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l

CodeForces - 601A The Two Routes

http://codeforces.com/problemset/problem/601/A 这道题没想过来, 有点脑筋急转弯的感觉了 本质上就是找最短路径 但是卡在不能重复走同一个点 ---->>> 这是来坑人的 因为这是一个完全图(不是被road 连接  就是被rail连接 ) 所以一定有一条直接连1 和 n的路径 那么只用找没有连 1 和 n 的路径的 那个图的最短路即可 然后这个dijkstra写的是O(V^2)的写法 以后尽量用优先队列的写法O(ElogV) 1 #includ